/*
 * generated by Xtext 2.29.0
 * (c) EvoAl Project
 */
package de.evoal.languages.model.ol.dsl.ui.labeling;

import com.google.inject.Inject;

import de.evoal.languages.model.base.Array;
import de.evoal.languages.model.base.Attribute;
import de.evoal.languages.model.base.Instance;
import de.evoal.languages.model.base.Literal;
import de.evoal.languages.model.ol.OptimisationModule;

import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.xtext.ui.label.DefaultEObjectLabelProvider;

/**
 * Provides labels for EObjects.
 * 
 * See https://www.eclipse.org/Xtext/documentation/310_eclipse_support.html#label-provider
 */
public class OptimisationLanguageLabelProvider extends DefaultEObjectLabelProvider {

	@Inject
	public OptimisationLanguageLabelProvider(final AdapterFactoryLabelProvider delegate) {
		super(delegate);
	}

	// Labels and icons can be computed like this:
	
	public String text(final OptimisationModule model) {
		return "Optimisation";
	}
	
	public String text(final Instance instance) {
		return instance.getDefinition().getName();
	}
	
	public String text(final Attribute attr) {
		if(attr.getValue() == null) {
			return attr.getDefinition().getName();
		} else if(attr.getValue() instanceof Literal) {
			return attr.getDefinition().getName() + " := " + super.doGetText(attr.getValue());
		} else if(attr.getValue() instanceof Array) {
			return attr.getDefinition().getName() + " := [...]";
		} else if(attr.getValue() instanceof Instance) {
			return attr.getDefinition().getName() + " := {...}";
		} else {
			return attr.getDefinition().getName() + " := ";
		}
	}
	
	public String text(final Literal literal) {
		return literal.getValue().toString();
	}
}
